unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Buttons, lazUTF8,
  OsPrinters,

  FileUtil, IpHtml,  ExtCtrls, StdCtrls, ComCtrls;

type
  TSimpleIpHtml = class(TIpHtml)
  public
    property OnGetImageX;
  end;

  { TMainForm }

  TMainForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    IpHtmlPanel1: TIpHtmlPanel;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure HTMLGetImageX(Sender: TIpHtmlNode; const URL: string;
      var Picture: TPicture);
    procedure IpHtmlPanelHotClick(Sender: TObject);
    procedure MainFormCreate(Sender: TObject);
  public
    procedure OpenHTMLFile(const Filename: string);
  end; 

var
  MainForm: TMainForm;
  Datei,Zurueck:string;

implementation
{$R *.lfm}
{ TMainForm }

procedure TMainForm.MainFormCreate(Sender: TObject);
begin
  Zurueck:='';
  Datei:='index.html';
  OpenHTMLFile(datei);
end;


procedure TMainForm.IpHtmlPanelHotClick(Sender: TObject);
var
  NodeA: TIpHtmlNodeA;
  NewFilename: String;
begin
  if IpHtmlPanel1.HotNode is TIpHtmlNodeA then begin
    NodeA:=TIpHtmlNodeA(IpHtmlPanel1.HotNode);
    NewFilename:=NodeA.HRef;
    Zurueck:=datei;
    OpenHTMLFile(NewFilename);
  end;
end;

procedure TMainForm.HTMLGetImageX(Sender: TIpHtmlNode; const URL: string;
  var Picture: TPicture);
var
  PicCreated: boolean;
begin
  try
    if FileExists(URL) then begin
      PicCreated := False;
      if Picture=nil then begin
        Picture:=TPicture.Create;
        PicCreated := True;
      end;
      Picture.LoadFromFile(URL);
    end;
  except
    if PicCreated then
      Picture.Free;
    Picture := nil;
  end;
end;


procedure TMainForm.Button1Click(Sender: TObject);
begin
 if Zurueck <>'' then OpenHTMLFile(Zurueck);
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  IpHtmlPanel1.PrintPreview;
  OpenHTMLFile(datei);
end;

procedure TMainForm.OpenHTMLFile(const Filename: string);
var
  fs: TFileStream;
  NewHTML: TSimpleIpHtml;
begin
  try
    fs:=TFileStream.Create(UTF8ToSys(Filename),fmOpenRead);
    try
      NewHTML:=TSimpleIpHtml.Create;
      NewHTML.OnGetImageX:=@HTMLGetImageX;
      NewHTML.LoadFromStream(fs);
    finally
      fs.Free;
    end;
    IpHtmlPanel1.SetHtml(NewHTML);
    statusbar1.SimpleText:='Du bist auf dieser Seite : '+Filename;
    datei:=Filename;
  except
    on E: Exception do
    begin
     statusbar1.SimpleText:='Die Seite '+Filename+' kann ich nicht öffnen';
    end;
  end;
end;

initialization
  {$I unit1.lrs}
end.

